SLASH_WFTRACKER1, SLASH_WFTRACKER2 = '/wft', '/wftracker'

	-- if BonusID 4746, Warforge
	-- 42, Speed
	-- 41,Leech
	-- 40,Avoidance
	-- 43, Indestructible
	-- 8810, Socketed
	-- 8811/8812, no bonus

-- FRAMES -- 
local Loot_Notifier_Event = CreateFrame("Frame")	

-- VARIABLE INITIALIZATION -- 
WFT_ENABLED = true
WFT_SHOW_NOTIFICATIONS = true

-- INDEX OF ITEMS -- 

WFT_HEAD_ITEMS = 1
WFT_NECK_ITEMS = 2
WFT_SHOULDER_ITEMS = 3
WFT_CHEST_ITEMS = 5
WFT_WAIST_ITEMS = 6
WFT_LEGS_ITEMS = 7
WFT_FEET_ITEMS = 8
WFT_WRIST_ITEMS = 9
WFT_HAND_ITEMS = 10
WFT_FINGER_ITEMS = 11
WFT_TRINKET_ITEMS = 12
WFT_BACK_ITEMS = 16
WFT_WEAPON_ITEMS = 13

-- INDEX OF UPGRADED ITEMS -- 

WFT_WARFORGED_ITEMS = 1
WFT_SOCKETED_ITEMS = 2
WFT_TERTIARY_ITEMS = 3
WFT_WARFORGED_SOCKETED_ITEMS = 4
WFT_WARFORGED_TERTIARY_ITEMS = 5
WFT_SOCKETED_TERTIARY_ITEMS = 6
WFT_WARFORGED_SOCKETED_TERTIARY_ITEMS = 7

-- INDEX OF TERTIARY ITEMS -- 

WFT_TERT_AVOIDANCE = 9
WFT_TERT_LEECH = 10
WFT_TERT_SPEED = 11
WFT_TERT_INDESTRUCTIBLE = 12

-- LOOT COUNT DATABASE -- 
local root = WFT_lootDatabase
	if not root then root = {}; WFT_lootDatabase = root; end

local name, addon = ...

-- HELPER FUNCTIONS --

function getCommaValue(amount)
  local formatted = amount
  while true do  
    formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1,%2')
    if (k==0) then
      break
    end
  end
  return formatted
end

function getTotalSocketableItems()
        tempArray = WFT_lootDatabase
        numberOfSocketableItems = 0

	for k,v in pairs(tempArray) do
		if v["index"] == WFT_HEAD_ITEMS or v["index"] == WFT_NECK_ITEMS or v["index"] == WFT_WAIST_ITEMS or v["index"] == WFT_WRIST_ITEMS or v["index"] == WFT_FINGER_ITEMS then 
			numberOfSocketableItems = numberOfSocketableItems+v["count"]
		end
	end
	return numberOfSocketableItems
end

function getPercentage(num1, num2)
	if num2 > 0 then
		return math.floor((num1/num2)*100)
	else	
		return 0
	end
end

-- REGISTER SLASH COMMANDS --

SlashCmd = function(msg)
	if msg == "" then
		print(string.char(10))
		print("\124cffffcc00\124h - Function Commands -")
		print("/wft list - Lists all items.")
		print("/wft totals - Overall item count by slot type.")
		print("/wft upgrades - Displays number of upgrades looted.")

		print(string.char(10))
		print("\124cffffcc00\124h - Option Commands -")
		print("/wft notify - Toggles the message on recieving loot.")
		print("/wft toggle - Toggles addon.")
		print("/wft reset - Resets the Loot Database.")
		print("/wft export - Exports the database (NYI).")
	end
	if msg == "list" then
		print(string.char(10))
		print("\124cffFF00D4\124h-- Loot Acquired --")
		tempArray = WFT_lootDatabase
		iteration = 0
		
		for k,v in pairs(tempArray) do
			print(v["name"]..' x '..getCommaValue(v["count"]))
			iteration = iteration+1
		end
		if iteration == 0 then
			print("No records of you getting loot.")
		end
		print(string.char(10))
	end
	if msg == "upgrades" then 
		local	tempArray1 = {}
		tempArray = WFT_lootDatabase
		subString = ""
		tertSubString = ""
		itemCount = 0
		totalCount = 0
		socketableItemCount = 0
		upgradedItemCount = 0
		isItemWarforged = false
		isItemSocketed = false
		isItemTertiary = false

		socketableItemCount = getTotalSocketableItems()

		for i = 1,12 do
			tempArray1[i] = 0
		end

		for k,v in pairs(tempArray) do
			subString = string.sub(v["name"],string.find(v["name"],"6710"),-30)
			itemCount = getCommaValue(v["count"])
			totalCount = totalCount + itemCount

			isItemWarforged = false
			isItemSocketed = false
			isItemTertiary = false

			-- WARFORGED -- 
			if string.find(subString,"4746") then
				isItemWarforged = true
				tempArray1[WFT_WARFORGED_ITEMS] = tempArray1[WFT_WARFORGED_ITEMS]+itemCount
			end
			-- SOCKETED -- 
			if string.find(subString,"8810") then
				isItemSocketed = true
				tempArray1[WFT_SOCKETED_ITEMS] = tempArray1[WFT_SOCKETED_ITEMS]+itemCount
			end
			-- TERTIARY -- 
			if string.find(subString,"40") or string.find(subString,"41") or string.find(subString,"42") or string.find(subString,"43") then
				if string.find(subString,"40") then
					tempArray1[WFT_TERT_AVOIDANCE] = tempArray1[WFT_TERT_AVOIDANCE]+itemCount
				elseif string.find(subString,"41") then
					tempArray1[WFT_TERT_LEECH] = tempArray1[WFT_TERT_LEECH]+itemCount
				elseif string.find(subString,"42") then
					tempArray1[WFT_TERT_SPEED] = tempArray1[WFT_TERT_SPEED]+itemCount
				elseif string.find(subString,"43") then
					tempArray1[WFT_TERT_INDESTRUCTIBLE] = tempArray1[WFT_TERT_INDESTRUCTIBLE]+itemCount
				end
				isItemTertiary = true
				tempArray1[WFT_TERTIARY_ITEMS] = tempArray1[WFT_TERTIARY_ITEMS]+itemCount
			end
			
			if isItemWarforged then
				if isItemSocketed and isItemTertiary then
					tempArray1[WFT_WARFORGED_SOCKETED_TERTIARY_ITEMS] = tempArray1[WFT_WARFORGED_SOCKETED_TERTIARY_ITEMS]+itemCount
				elseif isItemSocketed then
					tempArray1[WFT_WARFORGED_SOCKETED_ITEMS] = tempArray1[WFT_WARFORGED_SOCKETED_ITEMS]+itemCount
				elseif isItemTertiary then
					tempArray1[WFT_WARFORGED_TERTIARY_ITEMS] = tempArray1[WFT_WARFORGED_TERTIARY_ITEMS]+itemCount
				end
			elseif isItemTertiary then
					if isItemSocketed then
						tempArray1[WFT_SOCKETED_TERTIARY_ITEMS] = tempArray1[WFT_SOCKETED_TERTIARY_ITEMS]+itemCount
					end
			end
		end

		for i = 1,3 do
			upgradedItemCount = upgradedItemCount+tempArray1[i]
		end

		upgradedItemCount = upgradedItemCount - 2*(tempArray1[WFT_WARFORGED_SOCKETED_TERTIARY_ITEMS])-tempArray1[WFT_WARFORGED_SOCKETED_ITEMS]-tempArray1[WFT_WARFORGED_TERTIARY_ITEMS]-tempArray1[WFT_SOCKETED_TERTIARY_ITEMS]

		print(string.char(10))
		print("Warforged Items - "..tempArray1[WFT_WARFORGED_ITEMS])
		print("Socketed Items - "..tempArray1[WFT_SOCKETED_ITEMS])
		print("Tertiary Items - "..tempArray1[WFT_TERTIARY_ITEMS])
		print("Warforged+Socketed Items - "..tempArray1[WFT_WARFORGED_SOCKETED_ITEMS])
		print("Warforged+Tertiary Items - "..tempArray1[WFT_WARFORGED_TERTIARY_ITEMS])
		print("Warforged+Socketed+Tertiary Items - "..tempArray1[WFT_WARFORGED_SOCKETED_TERTIARY_ITEMS])
		print("Tertiary+Socketed Items - "..tempArray1[WFT_SOCKETED_TERTIARY_ITEMS])
		print(string.char(10))
		print("Warforged Chance: "..getPercentage(tempArray1[WFT_WARFORGED_ITEMS],totalCount).."%")
		print("Socketed Chance: "..getPercentage(tempArray1[WFT_SOCKETED_ITEMS],socketableItemCount).."%")
		print("Tertiary Chance: "..getPercentage(tempArray1[WFT_TERTIARY_ITEMS],totalCount).."%")
		print(string.char(10))
		print("Avoidance Items: "..tempArray1[WFT_TERT_AVOIDANCE].." ("..getPercentage(tempArray1[WFT_TERT_AVOIDANCE],tempArray1[WFT_TERTIARY_ITEMS]).."%)")
		print("Leech Items: "..tempArray1[WFT_TERT_LEECH].." ("..getPercentage(tempArray1[WFT_TERT_LEECH],tempArray1[WFT_TERTIARY_ITEMS]).."%)")
		print("Speed Items: "..tempArray1[WFT_TERT_SPEED].." ("..getPercentage(tempArray1[WFT_TERT_SPEED],tempArray1[WFT_TERTIARY_ITEMS]).."%)")
		print("Indestructible Items: "..tempArray1[WFT_TERT_INDESTRUCTIBLE].." ("..getPercentage(tempArray1[WFT_TERT_INDESTRUCTIBLE],tempArray1[WFT_TERTIARY_ITEMS]).."%)")
		print(string.char(10))
		print("\124cffffcc00\124hUPGRADED ITEMS - "..upgradedItemCount.." ("..getPercentage(upgradedItemCount,totalCount).."%)")
		print("\124cffFF00D4\124hTOTAL ITEMS - "..totalCount)
	end
	if msg == "totals" then
		tempArray = WFT_lootDatabase
		tempArray2 = {}
		totalCount = 0
	
		for i = 1,34 do
			tempArray2[i] = 0
		end

		for k,v in pairs(tempArray) do
			tempArray2[v["index"]] = tempArray2[v["index"]]+getCommaValue(v["count"])
			totalCount = totalCount+getCommaValue(v["count"])
		end				

		print(string.char(10))
		print("\124cffffcc00\124hHead - \124cffFFFFFF\124h"..tempArray2[WFT_HEAD_ITEMS])
		print("\124cffffcc00\124hNeck - \124cffFFFFFF\124h"..tempArray2[WFT_NECK_ITEMS])
		print("\124cffffcc00\124hFinger - \124cffFFFFFF\124h"..tempArray2[WFT_FINGER_ITEMS])
		print("\124cffffcc00\124hWrist - \124cffFFFFFF\124h"..tempArray2[WFT_WRIST_ITEMS])
		print("\124cffffcc00\124hWaist - \124cffFFFFFF\124h"..tempArray2[WFT_WAIST_ITEMS])
		print("\124cffffcc00\124hChest - \124cffFFFFFF\124h"..tempArray2[WFT_CHEST_ITEMS])
		print("\124cffffcc00\124hHand - \124cffFFFFFF\124h"..tempArray2[WFT_HAND_ITEMS])
		print("\124cffffcc00\124hLegs - \124cffFFFFFF\124h"..tempArray2[WFT_LEGS_ITEMS])
		print("\124cffffcc00\124hFeet - \124cffFFFFFF\124h"..tempArray2[WFT_FEET_ITEMS])
		print("\124cffffcc00\124hBack - \124cffFFFFFF\124h"..tempArray2[WFT_BACK_ITEMS])
		print("\124cffffcc00\124hShoulder - \124cffFFFFFF\124h"..tempArray2[WFT_SHOULDER_ITEMS])
		print("\124cffffcc00\124hTrinket - \124cffFFFFFF\124h"..tempArray2[WFT_TRINKET_ITEMS])
		print("\124cffffcc00\124hWeapon - \124cffFFFFFF\124h"..tempArray2[WFT_WEAPON_ITEMS]+tempArray2[15]+tempArray2[17]+tempArray2[21]+tempArray2[12])
		print("\124cffFF00D4\124hTOTAL ITEMS - "..totalCount)
	end
	if msg == "reset" then
		local newArray = {}
		WFT_lootDatabase = newArray
		print("\124cffFF00D4\124h[WFT] Loot database has been reset.")
	end
	if msg == "toggle" then
		if WFT_ENABLED then
			WFT_ENABLED = false
			print("\124cffFF00D4\124h[WFT] Warforged Tracker disabled.")
		elseif not WFT_ENABLED then
			WFT_ENABLED = true
			print("\124cffFF00D4\124h[WFT] Warforged Tracker enabled.")
		end
	end
	if msg == "notify" then
		if WFT_SHOW_NOTIFICATIONS then
			WFT_SHOW_NOTIFICATIONS = false
			print("\124cffFF00D4\124h[WFT] Loot notifications disabled.")
		elseif not WFT_SHOW_NOTIFICATIONS then
			WFT_SHOW_NOTIFICATIONS = true
			print("\124cffFF00D4\124h[WFT] Loot notifications enabled.")
		end
	end
	if msg == "export" then
		print("\124cffFF00D4\124h[WFT] To export your database, you can go into ../WoW/_retail_/WTF/Account/<Account>/<Server>/<Character>/WFTracker.lua to backup the database")
	end	
end

-- REGISTER SLASH COMMANDS END --

SlashCmdList["WFTRACKER"] = SlashCmd

-- EVENT HANDLER -- 

Loot_Notifier_Event:RegisterEvent("CHAT_MSG_LOOT")
Loot_Notifier_Event:SetScript("OnEvent",
	function (self, event, ...)
		if WFT_ENABLED == false then return end
		
		local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9 = ...

		itemName, itemAmount = string.match(arg1 , "You receive loot: (.*)\.")

		if itemName == nil then
			itemName, itemAmount = string.match(arg1 , "You receive item: (.*)\.")
		end

		if itemName ~= nil then
			name = string.match(itemName, "(.*)x%d+")

			if name == nil then
				name = string.match(itemName, "(.*)")
			end
			
			amount = string.match(itemName, ".*x(%d+)")
			if amount ~= nil then
			elseif name ~= nil then
				amount = 1
			else
				print("WFT loot name or amount error skipped.....")
				return
			end
				name,link,qualityRating,iLevel,a5,a6,a7,a8,a9,a10,a11,itemType,a13,a14,expacLevel = GetItemInfo(itemName)			
				
				if string.find(link,"6710") and expacLevel==5 and (itemType==2 or itemType==4) then

					id = link:match("item:(%d+):")

					subString = string.sub(link,string.find(link,"6710"),-30)
					id = id..subString

					if WFT_lootDatabase[id] == nil then
						itemIndex = C_Item.GetItemInventoryTypeByID(link)	
						WFT_lootDatabase[id] = {}
						WFT_lootDatabase[id]["count"] = 0
						WFT_lootDatabase[id]["index"] = itemIndex
						WFT_lootDatabase[id]["name"] = link
					end
					
					WFT_lootDatabase[id]["count"] = WFT_lootDatabase[id]["count"]+amount
					if WFT_SHOW_NOTIFICATIONS then
						print("WFTracker: "..link.." item acquired!")
					end
				end
		end
end)

-- EVENT HANDLER END -- 